#include "IRremote.h"
#include <Servo.h>

// Déclaration du servomoteur 
Servo myservo;  
unsigned short val_servo=10;

// Numéro du pin sortie du récepteur 
long int res_val;
const int receiver = 11; 

// Indicateur lampe 
const int ServoON = 2;
const int ServoOFF = 3;

// Pin servomoteur 
const int ServoPin = 9;

// Déclaration d'un objet IRrecv
IRrecv irrecv(receiver);           
decode_results results;            

void setup()  
{
  // Init servo-moteur 
  myservo.attach(ServoPin); 
  
  // Init du récepteur 
  irrecv.enableIRIn();
  
  // Indicateur mise en marche 
  pinMode(ServoON, OUTPUT);
  pinMode(ServoOFF, OUTPUT);
  
  // Initialisation 
  digitalWrite(ServoON, LOW);   
  digitalWrite(ServoOFF, HIGH);                                        
  myservo.write(10); 
}

void loop()  
{
  // Lecture de la télécommande 
  if (irrecv.decode(&results))
  {
    // Récupération du code   
    res_val = results.value;
    
    // Application d'un mode de démarrage du moteur
    MotorMode(res_val);
     
    // Réception de la nouvelle valeur
    irrecv.resume();
  }  
}

void MotorMode(long int res_val) 
{
  switch(res_val)
  {
    // Mode 1: Incrémentation de l'angle (+10)
    case 0xFF30CF: // Code '1'   

      // Incrémation postion 
      val_servo=val_servo+10; 
      if (val_servo>=180)
      {
        val_servo=10;
        myservo.write(val_servo); 
        digitalWrite(ServoOFF, HIGH); 
        break;
      }
      myservo.write(val_servo); 
      digitalWrite(ServoON, HIGH);
      digitalWrite(ServoOFF, LOW);
      delay(100);
      digitalWrite(ServoON, LOW);
      break;
  
    // Mode 2: Initialisation de l'angle à 10 degré 
    case 0xFF18E7: // Code '2'    
      
      // Initialisation servo 
      digitalWrite(ServoON, LOW);
      digitalWrite(ServoOFF, HIGH);
      val_servo=10;
      myservo.write(val_servo); 
      delay(100);
      break;
  }
}
